-------------------------------------------------------------------------------
-- my_gpio_wrapper.vhd
-------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

library common_v1_00_a;
use common_v1_00_a.all;

library gpio_mod_v1_00_b;
use gpio_mod_v1_00_b.all;

entity my_gpio_wrapper is
  port (
    OPB_Clk : in std_logic;
    OPB_Rst : in std_logic;
    OPB_ABus : in std_logic_vector(0 to 31);
    OPB_BE : in std_logic_vector(0 to 3);
    OPB_DBus : in std_logic_vector(0 to 31);
    OPB_RNW : in std_logic;
    OPB_select : in std_logic;
    OPB_seqAddr : in std_logic;
    GPIO_DBus : out std_logic_vector(0 to 31);
    GPIO_errAck : out std_logic;
    GPIO_retry : out std_logic;
    GPIO_toutSup : out std_logic;
    GPIO_xferAck : out std_logic;
    GPIO_IO_I0 : in std_logic;
    GPIO_IO_I1 : in std_logic;
    GPIO_IO_I2 : in std_logic;
    GPIO_IO_I3 : in std_logic;
    GPIO_IO_I4 : in std_logic;
    GPIO_IO_I5 : in std_logic;
    GPIO_IO_I6 : in std_logic;
    GPIO_IO_I7 : in std_logic;
    GPIO_IO_I8 : in std_logic;
    GPIO_IO_I9 : in std_logic;
    GPIO_IO_I10 : in std_logic;
    GPIO_IO_I11 : in std_logic;
    GPIO_IO_I12 : in std_logic;
    GPIO_IO_I13 : in std_logic;
    GPIO_IO_I14 : in std_logic;
    GPIO_IO_I15 : in std_logic;
    GPIO_IO_O0 : out std_logic;
    GPIO_IO_O1 : out std_logic;
    GPIO_IO_O2 : out std_logic;
    GPIO_IO_O3 : out std_logic;
    GPIO_IO_O4 : out std_logic;
    GPIO_IO_O5 : out std_logic;
    GPIO_IO_O6 : out std_logic;
    GPIO_IO_O7 : out std_logic;
    GPIO_IO_O8 : out std_logic;
    GPIO_IO_O9 : out std_logic;
    GPIO_IO_O10 : out std_logic;
    GPIO_IO_O11 : out std_logic;
    GPIO_IO_O12 : out std_logic;
    GPIO_IO_O13 : out std_logic;
    GPIO_IO_O14 : out std_logic;
    GPIO_IO_O15 : out std_logic
  );
end my_gpio_wrapper;

architecture STRUCTURE of my_gpio_wrapper is

  component gpio_mod is
    generic (
      C_BASEADDR : std_logic_vector;
      C_HIGHADDR : std_logic_vector;
      C_OPB_DWIDTH : integer;
      C_OPB_AWIDTH : integer;
      C_GPIO_WIDTH : integer;
      C_ALL_INPUTS : integer
    );
    port (
      OPB_Clk : in std_logic;
      OPB_Rst : in std_logic;
      OPB_ABus : in std_logic_vector(0 to C_OPB_AWIDTH-1);
      OPB_BE : in std_logic_vector(0 to C_OPB_DWIDTH/8-1);
      OPB_DBus : in std_logic_vector(0 to C_OPB_DWIDTH-1);
      OPB_RNW : in std_logic;
      OPB_select : in std_logic;
      OPB_seqAddr : in std_logic;
      GPIO_DBus : out std_logic_vector(0 to C_OPB_DWIDTH-1);
      GPIO_errAck : out std_logic;
      GPIO_retry : out std_logic;
      GPIO_toutSup : out std_logic;
      GPIO_xferAck : out std_logic;
      GPIO_IO_I0 : in std_logic;
      GPIO_IO_I1 : in std_logic;
      GPIO_IO_I2 : in std_logic;
      GPIO_IO_I3 : in std_logic;
      GPIO_IO_I4 : in std_logic;
      GPIO_IO_I5 : in std_logic;
      GPIO_IO_I6 : in std_logic;
      GPIO_IO_I7 : in std_logic;
      GPIO_IO_I8 : in std_logic;
      GPIO_IO_I9 : in std_logic;
      GPIO_IO_I10 : in std_logic;
      GPIO_IO_I11 : in std_logic;
      GPIO_IO_I12 : in std_logic;
      GPIO_IO_I13 : in std_logic;
      GPIO_IO_I14 : in std_logic;
      GPIO_IO_I15 : in std_logic;
      GPIO_IO_O0 : out std_logic;
      GPIO_IO_O1 : out std_logic;
      GPIO_IO_O2 : out std_logic;
      GPIO_IO_O3 : out std_logic;
      GPIO_IO_O4 : out std_logic;
      GPIO_IO_O5 : out std_logic;
      GPIO_IO_O6 : out std_logic;
      GPIO_IO_O7 : out std_logic;
      GPIO_IO_O8 : out std_logic;
      GPIO_IO_O9 : out std_logic;
      GPIO_IO_O10 : out std_logic;
      GPIO_IO_O11 : out std_logic;
      GPIO_IO_O12 : out std_logic;
      GPIO_IO_O13 : out std_logic;
      GPIO_IO_O14 : out std_logic;
      GPIO_IO_O15 : out std_logic
    );
  end component;

begin

  my_gpio : gpio_mod
    generic map (
      C_BASEADDR => X"FFFFC000",
      C_HIGHADDR => X"FFFFC0FF",
      C_OPB_DWIDTH => 32,
      C_OPB_AWIDTH => 32,
      C_GPIO_WIDTH => 16,
      C_ALL_INPUTS => 0
    )
    port map (
      OPB_Clk => OPB_Clk,
      OPB_Rst => OPB_Rst,
      OPB_ABus => OPB_ABus,
      OPB_BE => OPB_BE,
      OPB_DBus => OPB_DBus,
      OPB_RNW => OPB_RNW,
      OPB_select => OPB_select,
      OPB_seqAddr => OPB_seqAddr,
      GPIO_DBus => GPIO_DBus,
      GPIO_errAck => GPIO_errAck,
      GPIO_retry => GPIO_retry,
      GPIO_toutSup => GPIO_toutSup,
      GPIO_xferAck => GPIO_xferAck,
      GPIO_IO_I0 => GPIO_IO_I0,
      GPIO_IO_I1 => GPIO_IO_I1,
      GPIO_IO_I2 => GPIO_IO_I2,
      GPIO_IO_I3 => GPIO_IO_I3,
      GPIO_IO_I4 => GPIO_IO_I4,
      GPIO_IO_I5 => GPIO_IO_I5,
      GPIO_IO_I6 => GPIO_IO_I6,
      GPIO_IO_I7 => GPIO_IO_I7,
      GPIO_IO_I8 => GPIO_IO_I8,
      GPIO_IO_I9 => GPIO_IO_I9,
      GPIO_IO_I10 => GPIO_IO_I10,
      GPIO_IO_I11 => GPIO_IO_I11,
      GPIO_IO_I12 => GPIO_IO_I12,
      GPIO_IO_I13 => GPIO_IO_I13,
      GPIO_IO_I14 => GPIO_IO_I14,
      GPIO_IO_I15 => GPIO_IO_I15,
      GPIO_IO_O0 => GPIO_IO_O0,
      GPIO_IO_O1 => GPIO_IO_O1,
      GPIO_IO_O2 => GPIO_IO_O2,
      GPIO_IO_O3 => GPIO_IO_O3,
      GPIO_IO_O4 => GPIO_IO_O4,
      GPIO_IO_O5 => GPIO_IO_O5,
      GPIO_IO_O6 => GPIO_IO_O6,
      GPIO_IO_O7 => GPIO_IO_O7,
      GPIO_IO_O8 => GPIO_IO_O8,
      GPIO_IO_O9 => GPIO_IO_O9,
      GPIO_IO_O10 => GPIO_IO_O10,
      GPIO_IO_O11 => GPIO_IO_O11,
      GPIO_IO_O12 => GPIO_IO_O12,
      GPIO_IO_O13 => GPIO_IO_O13,
      GPIO_IO_O14 => GPIO_IO_O14,
      GPIO_IO_O15 => GPIO_IO_O15
    );

end architecture STRUCTURE;
