library IEEE;
use IEEE.STD_Logic_1164.all, IEEE.Numeric_STD.all;
 
entity YCrCb_demultiplexer is
   port(
      reset:              in std_logic;
	clock:              in std_logic;
      YCrCb_in:           in std_logic_vector (9 downto 0);
      Y_out:              out std_logic_vector (9 downto 0);
      Cr_out:             out std_logic_vector (9 downto 0);
      Cb_out:             out std_logic_vector (9 downto 0)
   );
end entity YCrCb_demultiplexer;

architecture demultiplexer of YCrCb_demultiplexer is
   signal counter_value: unsigned(1 downto 0);
begin
   
   counter: process(clock)
	variable value: unsigned(1 downto 0);
   begin
      if rising_edge(clock) then
     	   if(reset = '1') then
	      value := "00";
	   else
      	value := value + 1;
         end if;
	end if;
      counter_value <= value;
	end process counter;
	
   demultiplexing: process(clock)
   begin
     if(counter_value = "00") then
	  Cb_out <= YCrCb_in;
     elsif(counter_value = "01") then
        Y_out <= YCrCb_in;
     elsif(counter_value = "10") then
        Cr_out <= YCrCb_in;
     else
        Y_out <= YCrCb_in;
     end if;
   end process demultiplexing;

end architecture demultiplexer;




