
library IEEE;
use IEEE.STD_Logic_1164.all, IEEE.Numeric_STD.all;
 
entity video_block is
   port(
      reset:            in std_logic;
      clock:            in std_logic;
	YCrCb_in:         in std_logic_vector (9 downto 0);
      pixel_data_in:    in std_logic_vector (9 downto 0);
	synch_data_in:    in std_logic_vector (9 downto 0);
	YCrCb_out:        out std_logic_vector (9 downto 0);
   	pixel_data_out:	out std_logic_vector (9 downto 0);
	synch_data_out:    out std_logic_vector (9 downto 0);
      reset_out:    out std_logic	
);
end entity video_block;

architecture synch_extractor of video_block is
    

		
   begin

      selection: process(clock)   
		   
			variable count: integer range 0 to 287;
			variable data_selector: std_logic;	-- 0 for synch, 1 for pixel
			
		
		begin
		
		   if rising_edge(clock) then 
	            
                  if(reset = '1') then
		         data_selector := '1';
		      elsif(data_selector = '1')	then
		         if(YCrCb_in = "1111111111") then
				data_selector := '0';
				count := 287; 	  
      			synch_data_out <= YCrCb_in;
			      YCrCb_out <= synch_data_in;
			   else
		     	      pixel_data_out <= YCrCb_in;
				YCrCb_out <= pixel_data_in;
			   end if;
			elsif(data_selector = '0') then
			   if(count = 0) then
			      data_selector := '1';
			   else
				count := count - 1;
			   end if; 
			   synch_data_out <= YCrCb_in;
			   YCrCb_out <= synch_data_in;
			end if;
			reset_out <= not data_selector;   
		   end if;
	
		end process selection;
	

			   
end architecture synch_extractor;